#include "BuildSettings.h" // scheffnow - This is the renamed NK.c file
#include "InternalSettings.h" // where the more esoteric/programmerly things from BS.h got moved. NK 05-07-17

#include "events.h"
#include "sulan_shipslog.c"
#include "globals.c"
#include "animals.c"
#include "sea_ai\sea.c"
#include "ships\ships.c"
#include "Encounters\Encounters.c"
#include "worldmap\worldmap.c"
#include "locations\locations.c"
#include "Loc_ai\LAi_init.c"
#include "store\goods.h"
#include "cannons\cannons.c"
#include "nations\nations.c"
#include "particles.c"
#include "initinterface.c"
#include "characters\characters.c"
#include "interface\interface.h"
#include "store\storeutilite.c"
#include "dialog.c"
#include "quests\quests.c"
#include "islands\islands.c"
#include "reload.c"
#include "situations.c"
#include "battle_interface\loginterface.c"
#include "calendar.c"
#include "teleport.c"
#include "utils.c"
#include "ITEMS\items.h"
#include "ITEMS\itemLogic.c"
#include "ITEMS\items_utilite.c"
#include "sound\alias.c" // KK
#include "weather\WhrWeather.c"
#include "controls\controls.c"
#include "landencounters\landencounters.c"
#include "NK.c" // 05-07-03 NK for misc functions
#include "Reinit.c" // NK
#include "models\models.c" // scheffnow
// NK do this with loadsegment - #include "models\initModels.c" //scheffnow
#include "Characters\init\monks.c" // scheffnow
#include "CCCFunctions.c" // ccc
#include "CCCdirectsail.c" // ccc Jan07, directsail code
#include "elrapido.c" // El Rapido
#include "MAXIMUS_Functions.c" // MAXIMUS
#include "KB_routines.c"  // KBlack - to accomodate functions from other mods - initially for tuning ships mod
#include "Periods.c" // KK
#include "Screwface_functions.c" // Screwface
#include "officers.c"; //ASVS
#include "FCoHS\FCoHS_Main.c"; // Friendly Contact on High Seas Mod


extern void wdmInitWorldMap();
extern void UpdateWorldMap();
extern void InitGoods();
extern void InitStores();
// OK, I'm putting the function in store.h rather than using loadsegment. 05-07-12 - extern void StoreInit();
extern void InitItems();
extern void InitCharactersTables();
extern void InitCharactersNames();
extern void InitCharactersNamesRu(); // added by MAXIMUS
//extern void CreateCharacters();
extern void ExecuteConsole(); // NK

extern void BothQuestComplete(string sQuestName); // KK
extern void QuestComplete(string sQuestName); // KK
extern void StartStoryLine(); // KK

// NK  so you see the defs that are in Utils.c -->
native float Bring2RangeNoCheck(float fMin1, float fMax1, float fMin2, float fMax2, float fValue);
native float Bring2Range(float fMin1, float fMax1, float fMin2, float fMax2, float fValue);
/*float Bring2Range(float fMin1, float fMax1, float fMin2, float fMax2, float fValue)
{
	if(fValue < fMin2) { fValue = fMin2; }
	if(fValue > fMax2) { fValue = fMax2; }
	float fDelta = (fValue - fMin2) / (fMax2 - fMin2);
	return fMin1 + fDelta * (fMax1 - fMin1);
}*/
native float Degree2Radian(float fDegree);
native float Clampf(float fValue);
/*float Clampf(float fClamp)
{
	if(fClamp > 1.0) return 1.0;
	if(fClamp < 0.0) return 0.0;
	return fClamp;
}*/
// NK <--
native int RDTSC_B();
native int RDTSC_E(int iRDTSC);
//int onesec; // NK for speedtests.

#libriary "script_libriary_test"

#event_handler(NEW_GAME_EVENT,"NewGame");
#event_handler(GAME_OVER_EVENT,"GameOverE");
#event_handler("Control Activation","ProcessControls");
#event_handler("MainMenuKey","ProcessMainMenuKey");
#event_handler("InterfaceKey","ProcessInterfaceKey");
#event_handler("CameraPosAng","ProcessCameraPosAng");
// NK 05-07-10 for now do with normal controls. - #event_handler("Cheat","ProcessCheat");
#event_handler("Control Activation","ProcessCheat");
#event_handler("SeaDogs_ClearSaveData", "ClearLocationsSaveData");

// KK -->
ref ResurrectingOfficiant;
bool bSuppressResurrection = false;
// <-- KK

// PB: Tortuga Ladies -->
ref TortugaDame1;
ref TortugaDame2;
ref TortugaDame3;
// PB: Tortuga Ladies <--

void ProcessCheat()
{
	string sCheatName;
	ref mc;
	int rcPassengerID;
	ref rcPassenger;
	sCheatName = GetEventData();
	if (bKeyboardEnabled) return; // KK
	mc = GetMainCharacter();
	// NK 05-07-10 switch to using normal control activation -->
	if(ENABLE_CHEATMODE && HasSubStr(sCheatName, "Cheat"))
	{
		if(GetStoryline(FindCurrentStoryline()) == "WoodesRogers") return;	//JRH

		sCheatName = strcut(sCheatName, 5, strlen(sCheatName)-1);
		// NK <--
		switch(sCheatName)
		{
			case "God":
				if(LAi_IsImmortal(GetMainCharacter()))
				{
					LAi_SetImmortal(GetMainCharacter(), false);
					Log_SetStringToLog(TranslateString("","God mode") + " " + XI_ConvertString("OFF"));
				}else{

					LAi_SetImmortal(GetMainCharacter(), true);
					Log_SetStringToLog(TranslateString("","God mode") + " " + XI_ConvertString("ON"));
				}
			break;
			case "ShotGun":
				if(globalSGMode != false)
				{
					globalSGMode = false;
					Log_SetStringToLog(TranslateString("","Shotgun mode") + " " + XI_ConvertString("OFF"));
				}else{
					globalSGMode = true;
					Log_SetStringToLog(TranslateString("","Shotgun mode") + " " + XI_ConvertString("ON"));
				}
			break;

			case "Gold":
				mc.money = sti(mc.money) + 100000;
				mc.wealth = sti(mc.wealth) + 10000;
				Log_SetStringToLog("+ 100000 " + XI_ConvertString("Gold"));
				Log_SetStringToLog("+ 10000 " + XI_ConvertString("Wealth"));
			break;
			case "Skill":
				mc.skill.freeskill = sti(mc.skill.freeskill) + 50;
				Log_SetStringToLog("+ 50" + XI_ConvertString("SP"));
			break;
			/*case "Reputation":
				mc.reputation = REPUTATION_NEUTRAL;
				Log_SetStringToLog("Reputation Set to NEUTRAL");
			break;*/
			case "Morale":

			break;
			case "Encounters":
				if(CheckAttribute(mc,"worldmapencountersoff") == 0)
				{
					mc.worldmapencountersoff = "1";
					Log_SetStringToLog(TranslateString("","Worldmap encounters") + " " + XI_ConvertString("OFF"));
				}
				else
				{
					if(mc.worldmapencountersoff == "1")
					{
						mc.worldmapencountersoff = "0";
						Log_SetStringToLog(TranslateString("","Worldmap encounters") + " " + XI_ConvertString("ON"));
					}
					else
					{
						mc.worldmapencountersoff = "1";
						Log_SetStringToLog(TranslateString("","Worldmap encounters") + " " + XI_ConvertString("OFF"));
					}
				}
			break;
			case "MainCharacter":
				mc.model	= "Danielle";
				mc.sex = "woman";
				mc.FaceId = 30;
				mc.model.animation = "woman";
				mc.model.height = WOMAN_HEIGHT; // KK
			break;
			case "soundoff":
				SendMessage(&Sound,"ll",MSG_SOUND_SET_ENABLED,0);
				Log_SetStringToLog(XI_ConvertString("Sound") + " " + XI_ConvertString("OFF"));
			break;

	/* ==========     Additional cheat handlers added for cheats by RC, 04.nov.2003     ========== */
			case "LevelUp":
				/*mc.skill.freeskill = sti(mc.skill.freeskill) + 2;
				mc.rank = sti(mc.rank) + 1;*/
				mc.experience = CalculateExperienceFromRank(sti(mc.rank)+1);
				/*mc.perks.FreePoints = sti(mc.perks.FreePoints) + 1;
				LAi_SetHP(mc,LAi_GetCharacterMaxHP(mc) + 5.0,LAi_GetCharacterMaxHP(mc) + 5.0);
				Log_SetStringToLog("Level Up!");*/
				AddCharacterExpNS(&mc, 1); // NK do it via actual call 05-07-10
			break;

			case "FakeLevelUp":
				mc.skill.freeskill = sti(mc.skill.freeskill) + ADD_SKILLPOINTS_PERLEVEL; // TIH changed to user configurable setting Nov14'06
				mc.perks.FreePoints = sti(mc.perks.FreePoints) + 1;
				ChangeHPBonus(&mc, 5);
				ResetHP(&mc); // NK 05-07-10
				//LAi_SetHP(mc,LAi_GetCharacterMaxHP(mc) + 5.0,LAi_GetCharacterMaxHP(mc) + 5.0);
				Log_SetStringToLog(TranslateString("","Fake Level Up") + "!");
			break;

			case "Reputation":
				if (sti(mc.reputation) >= 0 && sti(mc.reputation) <= 10)
				{
					mc.reputation = 15;
					Log_SetStringToLog(XI_ConvertString("Reputation") + " " + XI_ConvertString("set to") + " " + GetTranslatedReputationForSex(mc, "Bloody Terror")); // PB: Display fix
					break;
				}
				if (sti(mc.reputation) >= 11 && sti(mc.reputation) <= 20) {
					mc.reputation = 25;
					Log_SetStringToLog(XI_ConvertString("Reputation") + " " + XI_ConvertString("set to") + " " + GetTranslatedReputationForSex(mc, "Swindler")); // PB: Display fix
					break;
				}
				if (sti(mc.reputation) >= 21 && sti(mc.reputation) <= 30) {
					mc.reputation = 35;
					Log_SetStringToLog(XI_ConvertString("Reputation") + " " + XI_ConvertString("set to") + " " + GetTranslatedReputationForSex(mc, "Rascal")); // PB: Display fix
					break;
				}
				if (sti(mc.reputation) >= 31 && sti(mc.reputation) <= 40) {
					mc.reputation = 45;
					Log_SetStringToLog(XI_ConvertString("Reputation") + " " + XI_ConvertString("set to") + " " + GetTranslatedReputationForSex(mc, "Neutral")); // PB: Display fix
					break;
				}
				if (sti(mc.reputation) >= 41 && sti(mc.reputation) <= 50) {
					mc.reputation = 55;
					Log_SetStringToLog(XI_ConvertString("Reputation") + " " + XI_ConvertString("set to") + " " + GetTranslatedReputationForSex(mc, "Bloke")); // PB: Display fix
					break;
				}
				if (sti(mc.reputation) >= 51 && sti(mc.reputation) <= 60) {
					mc.reputation = 65;
					Log_SetStringToLog(XI_ConvertString("Reputation") + " " + XI_ConvertString("set to") + " " + GetTranslatedReputationForSex(mc, "Matey")); // PB: Display fix
					break;
				}
				if (sti(mc.reputation) >= 61 && sti(mc.reputation) <= 70) {
					mc.reputation = 75;
					Log_SetStringToLog(XI_ConvertString("Reputation") + " " + XI_ConvertString("set to") + " " + GetTranslatedReputationForSex(mc, "Dashing")); // PB: Display fix
					break;
				}
				if (sti(mc.reputation) >= 71 && sti(mc.reputation) <= 80) {
					mc.reputation = 85;
					Log_SetStringToLog(XI_ConvertString("Reputation") + " " + XI_ConvertString("set to") + " " + GetTranslatedReputationForSex(mc, "Hero")); // PB: Display fix
					break;
				}
				if (sti(mc.reputation) >= 81 && sti(mc.reputation) <= 90) {
					mc.reputation = 5;
					Log_SetStringToLog(XI_ConvertString("Reputation") + " " + XI_ConvertString("set to") + " " + GetTranslatedReputationForSex(mc, "Horror of the High Seas")); // PB: Display fix
					break;
				}
			break;

			case "Officer1FakeLevelUp":
				rcPassengerID = GetOfficersIndex(mc, sti(1));
				if (sti(rcPassengerID) > -1)
				{
					rcPassenger = GetCharacter(sti(rcPassengerID));

					rcPassenger.skill.freeskill = sti(rcPassenger.skill.freeskill) + ADD_SKILLPOINTS_PERLEVEL; // TIH changed to user configurable setting Nov14'06
					rcPassenger.perks.FreePoints = sti(rcPassenger.perks.FreePoints) + 1;
					LAi_SetHP(rcPassenger,LAi_GetCharacterMaxHP(rcPassenger) + 5.0,LAi_GetCharacterMaxHP(rcPassenger) + 5.0);
					Log_SetStringToLog(TranslateString("","Fake Level Up") + " " + XI_ConvertString("for") + " " + rcPassenger.name + " " + rcPassenger.lastname + "!");
				}
				else
				{
					Log_SetStringToLog(TranslateString("","Error updating passenger, is passenger") + " 1 " + XI_ConvertString("missing?"));
				}
			break;

			case "Officer2FakeLevelUp":
				rcPassengerID = GetOfficersIndex(mc, sti(2));
				if (sti(rcPassengerID) > -1)
				{
					rcPassenger = GetCharacter(sti(rcPassengerID));

					rcPassenger.skill.freeskill = sti(rcPassenger.skill.freeskill) + ADD_SKILLPOINTS_PERLEVEL; // TIH changed to user configurable setting Nov14'06
					rcPassenger.perks.FreePoints = sti(rcPassenger.perks.FreePoints) + 1;
					LAi_SetHP(rcPassenger,LAi_GetCharacterMaxHP(rcPassenger) + 5.0,LAi_GetCharacterMaxHP(rcPassenger) + 5.0);
					Log_SetStringToLog(TranslateString("","Fake Level Up") + " " + XI_ConvertString("for") + " " + rcPassenger.name + " " + rcPassenger.lastname + "!");
				}
				else
				{
					Log_SetStringToLog(TranslateString("","Error updating passenger, is passenger") + " 2 " + XI_ConvertString("missing?"));
				}
			break;

			case "Officer3FakeLevelUp":
				rcPassengerID = GetOfficersIndex(mc, sti(3));
				if (sti(rcPassengerID) > -1)
				{
					rcPassenger = GetCharacter(sti(rcPassengerID));

					rcPassenger.skill.freeskill = sti(rcPassenger.skill.freeskill) + ADD_SKILLPOINTS_PERLEVEL; // TIH changed to user configurable setting Nov14'06
					rcPassenger.perks.FreePoints = sti(rcPassenger.perks.FreePoints) + 1;
					LAi_SetHP(rcPassenger,LAi_GetCharacterMaxHP(rcPassenger) + 5.0,LAi_GetCharacterMaxHP(rcPassenger) + 5.0);
					Log_SetStringToLog(TranslateString("","Fake Level Up") + " " + XI_ConvertString("for") + " " + rcPassenger.name + " " + rcPassenger.lastname + "!");
				}
				else
				{
					Log_SetStringToLog(TranslateString("","Error updating passenger, is passenger") + " 3 " + XI_ConvertString("missing?"));
				}
			break;
	/* ==========     End of editing by RC, 04.nov.2003     ========== */
		}
	}
}

object Camera;

void ProcessCameraPosAng()
{
	Camera.Pos.x = GetEventData();
	Camera.Pos.y = GetEventData();
	Camera.Pos.z = GetEventData();

	Camera.Ang.x = GetEventData();
	Camera.Ang.y = GetEventData();
	Camera.Ang.z = GetEventData();
}

void proc_break_video()
{
	trace("proc_break_video()");
	InterfaceStates.videoIdx = -1;
	Event("ievntEndVideo");
}

void Main()
{
//	LocationTestProcess();
//	return;
	Trace("Gauging: StartGauging");
	// NK speedtest calculate number of ticks in one second: 05-05-02
	/*int iRDTSC_main = RDTSC_B();
	SystemDelay(1000);
	onesec = RDTSC_E(iRDTSC_main);*/
	// NK <--

	LayerCreate("realize", 1);
	LayerCreate("sea_realize", 1);
	LayerCreate("iRealize", 1);
	LayerCreate("fader_realize", 1);
	LayerCreate("inf_realize", 1);

	ReloadProgressStart();
	ControlsInit(GetTargetPlatform(),true);
	nTeleportLocation = 1;
	sTeleportLocName = "Oxbay_port";

	BS_Reinit();//MAXIMUS & KK

// KK -->
	trace("Gauging: Storylines");
	InitStoryLines();

	trace("Gauging: Profiles");
	InitProfiles();
// <-- KK

	SetEventHandler("Control Activation","proc_break_video",0);
	InterfaceStates.Launched = false;
	SetEventHandler(EVENT_END_VIDEO,"Main_LogoVideo",0);
	InterfaceStates.videoIdx = 0;
	Event(EVENT_END_VIDEO);
	ReloadProgressEnd();
}

void Main_LogoVideo()
{

	int i = sti(InterfaceStates.videoIdx);
	trace("Main_LogoVideo() " + i);
	switch(i)
	{

	case 0:
		{
			InterfaceStates.videoIdx = 1;
			StartPostVideo("PiratesAhoyLogo",1);
			return;
		}
	break;

	case 1:
		{
			InterfaceStates.videoIdx = 2;
			StartPostVideo("WaltDisneyLogo",1);
			return;
		}
	break;

	case 2:
		{
			InterfaceStates.videoIdx = 3;
			StartPostVideo("AkellaLogo",1);
			return;
		}
	break;

	case 3:
		{
			InterfaceStates.videoIdx = 4;
			StartPostVideo("BethesdaLogo",1);
			return;
		}
	break;
	}

	DelEventHandler(EVENT_END_VIDEO,"Main_LogoVideo");
	DeleteClass(&aviVideoObj);
	Event("DoInfoShower","sl","game prepare",true);
	SetEventHandler("frame","Main_Start",1);
}
//*/

void Main_Start()
//void Main()
{
	ReloadProgressStart();

	DelEventHandler("frame","Main_Start");

	if( GetTargetPlatform()=="pc" )	ControlsInit(GetTargetPlatform(),false);
/*
	ControlsInit(GetTargetPlatform(),false);

	nTeleportLocation = 1;
	sTeleportLocName = "Falaise_de_fleur_port_01";
	sTeleportLocName = "Oxbay_port";

	NationsInit();
	EncountersInit();
	CannonsInit();
	ShipsInit();
	IslandsInit();
	WeatherInit();
	InitPerks();

	if(LoadSegment("store\initGoods.c"))
	{
		InitGoods();
		UnloadSegment("store\initGoods.c");
	}

	if(LoadSegment("Interface\BaseInterface.c"))
	{
		InitBaseInterfaces_main();
		InitBaseInterfaces();
		UnloadSegment("Interface\BaseInterface.c");
	}

	if(LoadSegment("Characters\Characters_names.c"))
	{
		InitCharactersNames();
		UnloadSegment("Characters\Characters_names.c");
	}

*/

	ReloadProgressUpdate();

	aref ardate = GetStorylineStartParams(FindCurrentStoryline());
	Environment.date.hour = ardate.date.hour;
	Environment.date.min = ardate.date.min;
	Environment.date.sec = ardate.date.sec;
	Environment.time = stf(ardate.date.hour) + stf(ardate.date.min)/60.0 + stf(ardate.date.sec)/3600.0;
	Environment.date.year = ardate.date.year;
	Environment.date.month = ardate.date.month;
	Environment.date.day = ardate.date.day;

	Trace("Gauging: initgame start");
	InitGame();
	Trace("Gauging: initgame done");
	ReloadProgressUpdate();

// KK -->
	CheckStorylines();

	/*Environment.date.hour = worldMap.date.hour;
	Environment.date.min = worldMap.date.min;
	Environment.date.sec = worldMap.date.sec;
	Environment.time = stf(worldMap.date.hour) + stf(worldMap.date.min)/60.0 + stf(worldMap.date.sec)/3600.0;
	Environment.date.year = worldMap.date.year;
	Environment.date.month = worldMap.date.month;	//Was "w rldMap."  Typo? Garbled? ccc mar20
	Environment.date.day = worldMap.date.day;*/
// <-- KK


	InterfaceStates.Buttons.Load.enable = true;

	Event("DoInfoShower","sl","game prepare",false);

	GetInterfaceParameters(); // added by MAXIMUS
	GetLanguageParameters(); // added by MAXIMUS
	LaunchMainMenu();
	//LaunchLoadGame();

	//SetMainCharacterIndex(1);
	//LoadMainCharacterInFirstLocation("Oxbay_town", "", "");

	ReloadProgressEnd();
}

void SaveGame()
{
	DelEventHandler("evntSave","SaveGame");
	string saveName = GetEventData();//MAXIMUS: looks like these changes are resolving troubles with save -[partially stolen from AOP]->
	string saveData = GetEventData();

	aref arTmp;
	if(!FindClass(&arTmp,"fader"))
	{
		SaveEngineState(saveName);
		ISetSaveData(saveName,saveData);
	}

	PostEvent("DoInfoShower",1,"sl","save game",false);
	ClearScreenShoter();//MAXIMUS: looks like these changes are resolving troubles with save <-[partially stolen from AOP]-
// KK -->
	// Screwface
	string storyline = GetStoryline(FindCurrentStoryline());
	if(CheckAttribute(Globalsettings,"profile."+storyline+".len")) stringlen = Globalsettings.profile.(storyline).len;
	if(stringlen != 0)
	{
		qsFileName = "-=" + strleft(GetCurrentProfile(storyline),stringlen) + "=- QuickSave";
	}
	else
	{
		string qsFileName = "-=" + GetCurrentProfile(GetStoryline(FindCurrentStoryline())) + "=- QuickSave";
	}
	if (HasSubStr(saveName, qsFileName)) {
		if (FindFile("SAVE\" + GetStorylineDir(FindCurrentStoryline()), "*", qsFileName) == "") {
			Log_SetStringToLog(TranslateString("","Quicksave") + ": " + TranslateString("","FAILED") + "!");
		} else {
			Log_SetStringToLog(TranslateString("","Quicksave") + ": " + TranslateString("","OK"));
		}
	}
	DeleteAttribute(GetMainCharacter(), "KrakenAttack");	// PB: Kraken Attack
	DeleteAttribute(GetMainCharacter(), "ship.speedburst");	// PB: Black Pearl & Queen Anne's Revenge
// <-- KK
}

void LoadGame()
{
	string saveName = GetEventData();

	DeleteEntities();
	ClearEvents();
	ClearPostEvents();

	CreateEntity(&LanguageObject,"obj_strservice");
	CreateEntity(&reload_fader, "fader");
	SendMessage(&reload_fader, "ls", FADER_PICTURE, FindReloadPicture("loading_game.tga")); // KK
	SendMessage(&reload_fader, "lfl", FADER_IN, RELOAD_TIME_FADE_IN, true);
	ReloadProgressStart();
	ref pchar = GetMainCharacter(); // KK
	pchar.savegamename = saveName;
	SetEventHandler("frame","LoadGame_continue",1);
}

void LoadGame_continue()
{
// KK -->
	ref pchar = GetMainCharacter();
	DelEventHandler("frame","LoadGame_continue");
	LoadEngineState(PChar.savegamename);
	DeleteAttribute(PChar, "savegamename");
// <-- KK
	trace("Done loading");
}

void InterfaceDoExit()
{
	string segName = ""; // KK
	DelEventHandler("frame","InterfaceDoExit");
	InterfaceStates.Launched=false;
	if(sti(InterfaceStates.doUnFreeze)==true)
	{
		SendMessage(&GameInterface,"l",MSG_INTERFACE_RELEASE);
		if(!IsEntity(&aviVideoObj))
		{
			if( bSeaActive && !bAbordageStarted )
			{
				LayerFreeze("sea_realize",false);
				LayerFreeze("sea_execute",false);
				if(CheckAttribute(GetMainCharacter(),"setcolours")) // PB: Only update flags if needed
				{
					DeleteAttribute(GetMainCharacter(),"setcolours");
					// Screwface: Just refresh the player and companion flags
					if(!CheckAttribute(GetMainCharacter(),"Waitdelay"))
					{
						RefreshMc_n_companionsFlags();
						waitdelay();
					}
					else
					{
						// The player n companions flags will be refresh at the AI sea Update
						Trace("DoSetFlags Delayed to AI Sea Update");
						Characters[GetMainCharacterIndex()].Delayrefresh = true;
						Characters[GetMainCharacterIndex()].torefresh = true;
					}
				}
			}
			else
			{
				LayerFreeze("realize",false);
				LayerFreeze("execute",false);
			}
		//	RefreshFlags(); // KK
			ref mchr = GetMainCharacter();
			CheckReloadAction(mchr, "");
			if (CheckAttribute(mchr, "BoxName")) DeleteAttribute(mchr, "BoxName.update");
			if (CheckAttribute(mchr, "activeItem")) DeleteAttribute(mchr, "activeItem.update");
			CheckCharacterAction();
		}
		DeleteAttribute(&GameInterface,"");
	}
	switch(interfaceResultCommand)
	{
		case RC_INTERFACE_FORTCAPTURE_EXIT:
			ReloadAfterFortCapture();
			break;

		case RC_INTERFACE_DO_NOTHING:
			break;
		case RC_INTERFACE_MAIN_MENU_EXIT:
			break;
		/* dead Aug27'06
		case RC_INTERFACE_DO_NEW_GAME:
			InterfaceStates.doUnFreeze = false;
			DeleteEntities();
			//DeleteSeaEnvironment();
			musicName = "";
			oldMusicName = "";
			ResetSoundScheme();
			StopSound(0,0);
			ReleaseSound(0);
			ClearEvents();
			ClearPostEvents();

			if(LoadSegment("Interface\BaseInterface.c"))
			{
				InitBaseInterfaces_main();
				InitBaseInterfaces();
				UnloadSegment("Interface\BaseInterface.c");
			}


			LaunchSelectCharacter();

			//SetEventHandler("frame","NewGame",1);
			break;
		*/
		case RC_INTERFACE_DO_LOAD_GAME:
			//LoadGame();
// KK -->
			segName = GetStorylinePath(FindCurrentStoryline()) + "quests\both_reaction.c";
			if (SegmentIsLoaded(segName)) UnloadSegment(segName);
			segName = GetStorylinePath(FindCurrentStoryline()) + "quests\quests_reaction.c";
			if (SegmentIsLoaded(segName)) UnloadSegment(segName);
			segName = GetStorylinePath(FindCurrentStoryline()) + "SL_utils.c";
			if (SegmentIsLoaded(segName)) UnloadSegment(segName);
// <-- KK
			LaunchLoadGame();
			break;
		case RC_INTERFACE_DO_SAVE_GAME:
			LaunchSaveGame();
			break;

		case RC_INTERFACE_DO_OPTIONS:
			LaunchOptionScreen();
			break;
		case RC_INTERFACE_DO_CONTROLS:
			LaunchControlsScreen();
			break;
// added by MAXIMUS -->
		case RC_INTERFACE_DO_ABOUT_BUILD:
			LaunchAboutBuildScreen();
			break;
// added by MAXIMUS <--
		case RC_INTERFACE_DO_CREDITS:
			break;
		case RC_INTERFACE_DO_RESUME_GAME:
			break;
		case RC_INTERFACE_RANSACK_MAIN_EXIT:
			Return2SeaAfterAbordage();
			//wdmCreateMap(0.0,0.0,0.0);
			break;
		// boal Cabin 09.09.03 -->
		case RC_INTERFACE_CABIN_MAIN_EXIT:
			Return2SeaAfterDeck(); // KK
			break;
		// boal Cabin 09.09.03 <--

		// MAXIMUS deck -->
		case RC_INTERFACE_DECK_MAIN_EXIT:
			Return2SeaAfterDeck();
			break;
		case RC_INTERFACE_CREW_MAIN_EXIT:
			Return2SeaAfterDeck(); // KK
			break;
		// MAXIMUS deck <--

		case RC_INTERFACE_SELECT_STORYLINE_EXIT:
			DeleteEntities();
			ClearEvents();
			SetEventHandler("frame","NewGame",1);
			InterfaceStates.doUnFreeze = false;
			break;
// KK -->
		case RC_INTERFACE_DO_START:
			segName = GetStorylinePath(FindCurrentStoryline()) + "quests\both_reaction.c";
			if (SegmentIsLoaded(segName)) UnloadSegment(segName);
			segName = GetStorylinePath(FindCurrentStoryline()) + "quests\quests_reaction.c";
			if (SegmentIsLoaded(segName)) UnloadSegment(segName);
			segName = GetStorylinePath(FindCurrentStoryline()) + "SL_utils.c";
			if (SegmentIsLoaded(segName)) UnloadSegment(segName);
			RefreshStorylines();
			LaunchSelectStoryline();
			break;

		case RC_INTERFACE_DO_CUSTOMIZATION:
			LaunchCustomization();
			break;

		case RC_INTERFACE_OPTIONSCREEN_EXIT:
			Event("DoInfoShower","sl","MainMenuLaunch",true);
			LaunchMainMenu();
			break;
// <-- KK
	}
}

void EngineLayersOffOn(bool on)
{
	//LayerSetRealize("realize",on);
	//LayerSetExecute("execute",on);
	on = !on;
	LayerFreeze("realize",on);
	LayerFreeze("execute",on);
	if(!bAbordageStarted) { // KK
		LayerFreeze("sea_realize",on);
		LayerFreeze("sea_execute",on);
	}
	//LayerFreeze("sun_trace",on);
	//LayerFreeze("sea_reflection",on);
	//LayerFreeze("shadow",on);
	//LayerFreeze("ship_cannon_trace",on);
	//LayerFreeze("hull_trace",on);
	//LayerFreeze("mast_ship_trace",on);
	//LayerFreeze("sails_trace",on);
}

string seadogs_saveFrom = "";

// KK -->
void OnSave()
{
	Set_inDialog_Attributes();//MAXIMUS: VERY strange, but it's needed
	seadogs_saveFrom = "";
	if (IsEntity(&worldMap)) {
		seadogs_saveFrom = "world map";		//Was "seadogs_sav From"  ccc mar20
		return;
	}
	if (bSeaActive) {
		seadogs_saveFrom = "sea";
		SaveAtSea();
		return;
	}
	int ldLoc = FindLoadedLocation();
	if (ldLoc < 0 || ldLoc >= nLocationsNum) {
		trace("OnSave() -> unknown character location");
		return;
	}
	seadogs_saveFrom = "location";
	SendMessage(&Locations[ldLoc], "l", MSG_LOCATION_SETCHRPOSITIONS);
	LAi_group_SaveInfo();
	PostEvent("SeaDogs_ClearSaveData", 200, "a", &Locations[ldLoc]);
}

void SaveAtSea()
{
	// Screwface : It seems that if we do a save at sea and a reload, we lost the current load of balls & gunpowder
	// This code save this charge to re-add it at the load at sea
	ref Pchar = GetMainCharacter();
	ref rCannon; makeref(rCannon,Cannon[GetCaracterShipCannonsType(Pchar)]);
	if(CANNONPOWDER_MOD)
	{
		int fireGunpowder = 0;
		if(CheckAttribute(rCannon,"gunpowder")) fireGunpowder = sti(rCannon.gunpowder)*sti(GetCannonCurQuantity(Pchar));
		Pchar.save.gunpowder = fireGunpowder;
	}
	Pchar.save.currentcharge = Pchar.Ship.Cannons.Charge.Type;
	Pchar.save.currentchargeqty = sti(GetCannonCurQuantity(Pchar));
	// Screwface : end

	SendMessage(&AIBalls, "l", MSG_MODEL_RELEASE);
	for (int i = 0; i < iNumShips; i++)
	{
		if (Ships[i] < 0) continue;
		ref rCharacter = GetCharacter(Ships[i]);
		if (!CheckAttribute(rCharacter, "Ship")) continue;
		ref rShip = GetShipByType(GetCharacterShipType(rCharacter));
		if (!CheckAttribute(rCharacter, "Ship.Masts")) continue;
		aref arMasts; makearef(arMasts, rCharacter.Ship.Masts);
		rCharacter.Ship.old.Masts = "";
		aref arOldMasts; makearef(arOldMasts, rCharacter.Ship.old.Masts);
		CopyAttributes(arOldMasts, arMasts);
	}
}
// <-- KK

void ClearLocationsSaveData()
{
	aref loc = GetEventData();
	SendMessage(loc, "l", MSG_LOCATION_CLRCHRPOSITIONS);
}

int actLoadFlag = 0;
void OnLoad()
{
	actLoadFlag = 1;


	//NationsInit();
	ResetSound();

	//CreateClass("dummy");

	if(LoadSegment("Interface\BaseInterface.c"))
	{
		//InitBaseInterfaces_main();
		InitBaseInterfaces();
		UnloadSegment("Interface\BaseInterface.c");
	}

	ReloadProgressUpdate();

// KK -->
	//LoadProfileOptions();

	if (FindFile("PROGRAM\" + GetStorylinePath(FindCurrentStoryline()), "*.c", "SL_utils.c") != "") {
		LoadSegment(GetStorylinePath(FindCurrentStoryline()) + "SL_utils.c");
	}
	bool bSegLoaded = false;
	bSegLoaded = LoadSegment(GetStorylinePath(FindCurrentStoryline()) + "quests\both_reaction.c");
	if (!bSegLoaded) {
		trace("ERROR: both_reaction.c not loaded!!!");
		return;
	}
	bSegLoaded = LoadSegment(GetStorylinePath(FindCurrentStoryline()) + "quests\quests_reaction.c");
	if (!bSegLoaded) {
		trace("ERROR: quests_reaction.c not loaded!!!");
		return;
	}

	ReloadProgressUpdate();
// <-- KK

	DialogsInit();
	//IslandsInit();
	//LocationInit();

	ReloadProgressUpdate();

	InitCharacterEvents();
	ReloadProgressUpdate();
	QuestsInit();
	ReloadProgressUpdate();
	InitTeleport();
	ReloadProgressUpdate();
	InitParticles();
	ReloadProgressUpdate();
	//ImportFuncTest();

//	InterfaceStates.Buttons.New.enable = false;		// LDH can only start new game if you restart the program - 19Apr09
// (this is because initialization of a new game does not work correctly after having loaded a game!!!)

	InterfaceStates.Buttons.Resume.enable = true;
	InterfaceStates.Buttons.Save.enable = true;
	InterfaceStates.Buttons.Load.enable = true;

// KK -->
	switch (seadogs_saveFrom)
	{
		case "location":
			ref mainchar = GetMainCharacter();
			LoadMainCharacterInFirstLocation(mainchar.location, "reload", "", mainchar.location.from_sea); // KK
			int ldLoc = FindLoadedLocation();
			if(ldLoc >= 0)
			{
				SendMessage(&Locations[ldLoc], "l", MSG_LOCATION_TLPCHRPOSITIONS);
			}
		break;
		case "world map":
			wdmLoadSavedMap();
		break;
		case "sea":
			LoadAtSea();
		break;
		// default:
			Trace("Unknow seadogs_saveFrom == " + seadogs_saveFrom);
	}
// <-- KK

	//ReloadEndFade();
	EngineLayersOffOn(true);
	//NewGame();
	DialogRun = false;
	InterfaceStates.Launched = false;

	ReloadProgressUpdate();

	PerkLoad();

	ReloadProgressUpdate();

	// Screwface
	SaveGlobalOptions();
	InitProfiles(); // To avoid profiles which were created after the one we load, are not present in the load profile screen !
	// Screwface : end

	ReloadProgressEnd();

	actLoadFlag = 0;
}

void NewGame()
{
	GetLanguageParameters();
	Trace("Gauging: start new game");
	DeleteEntities();
	DelEventHandler("frame","NewGame");

	// PB: Storyline Specific Start New Game Screens -->
	string LoadingScreen = "Quest_"+GetStoryline(FindCurrentStoryline())+".tga";
	string TextureFolder = "RESOURCE\Textures\Loading\"+ LanguageGetLanguage() +"\";
	if(FindFile(TextureFolder, "*.tx", LoadingScreen+".tx") == "") LoadingScreen = "new_game.tga";
	// PB: Storyline Specific Start New Game Screens <--

	CreateEntity(&LanguageObject,"obj_strservice");
	CreateEntity(&reload_fader, "fader");
	SendMessage(&reload_fader, "ls", FADER_PICTURE, FindReloadPicture(LoadingScreen)); // KK
	SendMessage(&reload_fader, "lfl", FADER_IN, RELOAD_TIME_FADE_IN, true);

	SetEventHandler("frame","NewGame_continue",1);
}

void NewGame_continue()
{
	ReloadProgressStart();
	InitOfficerTypes();//ASVS

	// NK only fully create characters _here_  05-04-07 to speed game start
	/*bool tmpbool = LogsToggle;
	LogsToggle = true;*/
	// PB CharactersInit();
	/*LogsToggle = tmpbool*/
	/*if(LoadSegment("characters\characters_init.c"))
	{
		bool tmpbool = LogsToggle;
		LogsToggle = true;
		CreateCharacters(); // NK add bool 05-04-07 to speed game start
		LogsToggle = tmpbool
		UnloadSegment("characters\characters_init.c");
	}*/
	// NK <--

	DelEventHandler("frame","NewGame_continue");

	if(LoadSegment("Interface\BaseInterface.c"))
	{
		InitBaseInterfaces();
		Trace("Gauging: ng iface");
		UnloadSegment("Interface\BaseInterface.c");
	}

// KK -->
	aref ardate = GetStorylineStartParams(FindCurrentStoryline());
	Environment.date.hour = ardate.date.hour;
	Environment.date.min = ardate.date.min;
	Environment.date.sec = ardate.date.sec;
	Environment.time = stf(ardate.date.hour) + stf(ardate.date.min)/60.0 + stf(ardate.date.sec)/3600.0;
	Environment.date.year = ardate.date.year;
	Environment.date.month = ardate.date.month;
	Environment.date.day = ardate.date.day;

	InitPeriods();
	SetCurrentPeriod(GetPeriodFromYear(sti(ardate.date.year)));
	trace("Gauging: periods");

	SaveGlobalOptions();
// <-- KK

// PB -->
	NationsInit();
	CharactersInit();
	trace("Gauging: characters");
// <-- PB
// KK -->
	ShipsInit();
	trace("Gauging: ships");
// <-- KK

	Trace("Gauging: ng initgame start");
	InitGame();
	Trace("Gauging: ng initgame stop");

	InterfaceStates.Buttons.Resume.enable = true;
	InterfaceStates.Buttons.Save.enable = true;
	InterfaceStates.Buttons.Load.enable = true;
	//PlayMusic("MW battle2.mp3");

// KK -->
	ref PChar = GetMainCharacter();

	if (FindFile("PROGRAM\" + GetStorylinePath(FindCurrentStoryline()), "*.c", "SL_utils.c") != "") {
		LoadSegment(GetStorylinePath(FindCurrentStoryline()) + "SL_utils.c");
	}
	bool bSegLoaded = false;
	bSegLoaded = LoadSegment(GetStorylinePath(FindCurrentStoryline()) + "quests\both_reaction.c");
	if (!bSegLoaded) {
		trace("ERROR: both_reaction.c not loaded!!!");
		return;
	}
	bSegLoaded = LoadSegment(GetStorylinePath(FindCurrentStoryline()) + "quests\quests_reaction.c");
	if (!bSegLoaded) {
		trace("ERROR: quests_reaction.c not loaded!!!");
		return;
	}

	// do reinit up here 05-04-24
	Trace("Gauging: start reinit");
	Reinit(true, false); // 05-04-06 now do while still loading so we get nice reloadprogress update stuff...
	Trace("Gauging: reinit stop");
	if(GetStoryline(FindCurrentStoryline()) != "LegendJackSparrow" ) GiveModel2Player(PChar.model, true); // PB: Ensure that you have your starting outfit available

	ReloadProgressUpdate();

	InitTownNationalities(); // PB
	InitRelations();
	trace("Gauging: initial relations");
	InitGroups();
	trace("Gauging: characters groups");

	ReloadProgressUpdate();
	Trace("Gauging: load mch in first");

	if (LoadSegment(GetStorylinePath(FindCurrentStoryline()) + "StartStoryline.c")) {
		StartStoryLine();
		UnloadSegment(GetStorylinePath(FindCurrentStoryline()) + "StartStoryline.c");
	}
// <-- KK

	Trace("Gauging: done load mch in first");
	ReloadProgressUpdate(); // NK

	CleanStorylineObject(); // KK

	ReloadProgressEnd();

//	InterfaceStates.Buttons.New.enable = false; // Aconcagua, 2009-08-15: same as for loading, see LDH's change above

	//Aconcagua:
	UpdateSkillModifiers(GetMainCharacter());
}

/*
void NewGame()
{
	DeleteEntities();
	Environment.date.hour = 14.0;
	Environment.date.min = 0.0;
	Environment.date.sec = 0.0;
	Environment.time = 14.0;
	Environment.date.year = 1690;			//changed by KAM
	Environment.date.month = 8;
	Environment.date.day = 15;

	DelEventHandler("frame","NewGame");
	if(LoadSegment("Interface\BaseInterface.c"))
	{
		InitBaseInterfaces();
		UnloadSegment("Interface\BaseInterface.c");
	}
	InitGame();

	InterfaceStates.Buttons.Resume.enable = true;
	InterfaceStates.Buttons.Save.enable = true;
	InterfaceStates.Buttons.Load.enable = true;
	//PlayMusic("MW battle2.mp3");
	sTeleportLocName = "Oxbay_port";
	LoadMainCharacterInFirstLocation(sTeleportLocName, "reload2", sTeleportLocName);

}
*/
void InitGame()
{
	LayerCreate("realize", 1);
	LayerCreate("sea_realize", 1);
	LayerCreate("iRealize", 1);
	LayerCreate("fader_realize", 1);
	LayerCreate("inf_realize", 1);
	Trace("Gauging: createlayers");
	if(LoadSegment("store\initStore.c"))
	{
		InitStores();
		Trace("Gauging: stores");
		UnloadSegment("store\initStore.c");
	}
	InitSound();
	Trace("Gauging: sound");

	ReloadProgressUpdate();

	DeleteSeaEnvironment();
	Trace("Gauging: delete sea env");
	//CharactersInit();
	if(LoadSegment("worldmap\worldmap_init.c"))
	{
		wdmInitWorldMap();
		Trace("Gauging: wdmap");
		UnloadSegment("worldmap\worldmap_init.c");
	}
	IslandsInit();
	Trace("Gauging: islands");
	ReloadProgressUpdate();
	//return;
	LocationInit();
	Trace("Gauging: locations");
	ReloadProgressUpdate();
	DialogsInit();
	Trace("Gauging: dialogs");
	ReloadProgressUpdate();
	InitTeleport();
	Trace("Gauging: teleport");
	ReloadProgressUpdate();
	InitParticles();
	Trace("Gauging: particles");
	ReloadProgressUpdate();

	if(LoadSegment("items\initItems.c"))
	{
		InitItems();
		Trace("Gauging: items");
		UnloadSegment("items\initItems.c");
	}

	ReloadProgressUpdate();
	/*bool tmp = LogsToggle;
	LogsToggle = false;
	CharactersInit(false);
	LogsToggle = tmp;*/
	Trace("Gauging: char");
	ReloadProgressUpdate();
	QuestsInit();
	Trace("Gauging: quests");
	ReloadProgressUpdate();
	SeaAIGroupsInit();
	Trace("Gauging: sea ai groups");
	ReloadProgressUpdate();
	InitQuestMapEncounters();
	Trace("Gauging: questmapenc");
	ReloadProgressUpdate();
	InitLandRandomEncounters();
	Trace("Gauging: landenc");
	ReloadProgressUpdate();
// KK -->
	InitTownTable(true);
	trace("Gauging: towns");
	ReloadProgressUpdate();
// <-- KK

	// KK SetNextWeather("Blue Sky");
	//SetNextWeather("Violet Sky");


	ResetQuestMovie();

	ReloadProgressUpdate();

	LoadGlobalOptions();
	Trace("Gauging: load options");

// KK -->
	ReloadProgressUpdate();
	Alias_Init();
	trace("Gauging: Aliases");
	ReloadProgressUpdate();
// <-- KK

	InfoShowSetting();
	Trace("Gauging: infoshow");
}

// NK make ranged sidestep 05-07-21 -->
#event_handler("sidestep_event", "SideStep_Proc");
void SideStepControl(float mag, bool onoff)
{
	//trace("Sidestep control, mag " + mag + ", onoff is " + onoff);
	ref pchar = GetMainCharacter();
	if(onoff)
	{
		if(!CheckAttribute(pchar, "sidestep"))
		{
			//trace("no sidestep yet");
			pchar.sidestep = mag;
			event("sidestep_event", "l", GetMainCharacterIndex());
		}
	}
	else
	{
		//trace("deleting sidestep");
		DeleteAttribute(&pchar, "sidestep");
	}
}

void SideStep_Proc()
{
	int idx = GetEventData();
	ref chr = GetCharacter(idx);
	if(sti(InterfaceStates.Launched) || dialogRun)
	{
		DeleteAttribute(&chr, "sidestep")
	}
	else
	{
		if(CheckAttribute(chr, "sidestep"))
		{
			Sidestep(&chr, stf(chr.sidestep), SIDESTEP_CHECK);
			postevent("sidestep_event", SIDESTEP_DELAY, "l", idx);
		}
	}
}
// NK <--

bool ShowScreen = true;
int counter = 0;
// KK -->
string key_cpcode = "";
int iLMouseClickTime = 0;
int iLMouseClickCnt = 0;
string sLClickedNode = "";
int iRMouseClickTime = 0;
int iRMouseClickCnt = 0;
string sRClickedNode = "";

#event_handler("evntMouseBtnClickCheck", "CheckMouseBtnClick");
void CheckMouseBtnClick()
{
	int ibutton = GetEventData();
	if (ibutton == 0) {
		if (sLClickedNode != GetCurrentNode() || sti(InterfaceStates.GameTime.sec) - iLMouseClickTime > 0) {
			bLMouseDblClick = false;
			iLMouseClickCnt = 0;
			iLMouseClickTime = 0;
			sLClickedNode = "";
			return;
		}
		if (iLMouseClickCnt > 1) {
			bLMouseDblClick = true;
			iLMouseClickCnt = 0;
			iLMouseClickTime = 0;
			sLClickedNode = "";
			return;
		}
	} else {
		if (sRClickedNode != GetCurrentNode() || sti(InterfaceStates.GameTime.sec) - iLMouseClickTime > 0) {
			bRMouseDblClick = false;
			iRMouseClickCnt = 0;
			iRMouseClickTime = 0;
			sRClickedNode = "";
			return;
		}
		if (iLMouseClickCnt > 1) {
			bRMouseDblClick = true;
			iRMouseClickCnt = 0;
			iRMouseClickTime = 0;
			sRClickedNode = "";
			return;
		}
	}
	PostEvent("evntMouseBtnClickCheck", 1.0, "l", ibutton);
}
// <-- KK

void ProcessControls()
{
	string ControlName = GetEventData();
	float basetime = 1.0;
	//trace("ProcessControls() : " + ControlName);
	//if(ControlName == "WhrPrevWeather")	{ Whr_LoadNextWeather(-1); }
	//if(ControlName == "WhrNextWeather")	{ Whr_LoadNextWeather(1); }
	//if(ControlName == "WhrUpdateWeather")	{ Whr_UpdateWeather(true); } // NK 04-09-21 add bool to Whr_UpdateWeather

	if (ControlName == "NK_Key_") return; // KK
	if (bDisableAllCommands) return; // KK

	if(ControlName == "Help") RunHelpChooser();

	ref PChar = GetMainCharacter(); // NK moved here
	if(bKeyboardEnabled) // NK keyboard 05-07-21
	{
		//trace("KB enabled, control is " + ControlName);
		bool keydone = false;
		bool update = true;
		string key = getsymbol(ControlName, strlen(ControlName)-1);
		if(hassubstr(ControlName, "NK_Key_")) 
		{
			if (ControlName == "NK_KEY_DOT") key = "."; // KK
			KB_AddCharacter(key);
			keydone = true;
		}
// KK -->
		if (HasSubStr(ControlName, "NK_NP_")) {
			if (bKeyboardAlt == false) {
				KB_AddCharacter(key);
			} else {
				key_cpcode = key_cpcode + key;
			}
			keydone = true;
		}
// <-- KK
		if(!keydone)
		{
			switch(ControlName)
			{
// KK -->
				case "NK_KB_Shift_on": bKeyboardShift = !bKeyboardShift; keydone = true; break;
				case "NK_KB_Shift_off": bKeyboardShift = !bKeyboardShift; keydone = true; break;
				case "NK_KB_caps": bKeyboardShift = !bKeyboardShift; keydone = true; break;
				case "NK_KB_Control_on": bKeyboardControl = true; keydone = true; break;// MAXIMUS
				case "NK_KB_Control_off": bKeyboardControl = false; keydone = true; break;// MAXIMUS
				case "NK_KB_Alt_on":
					bKeyboardAlt = true;
					keydone = true;
				break;
				case "NK_KB_Alt_off":
					bKeyboardAlt = false;
					if (key_cpcode != "") {
					  if (strlen(key_cpcode) > 3) key_cpcode = strcut(key_cpcode, strlen(key_cpcode) - 4, strlen(key_cpcode) - 1);
					  int cpcode = sti(key_cpcode);
					  Event("Control Activation", "s", "NK_Key_" + ChrFromCode(cpcode));
						key_cpcode = "";
					}
					keydone = true;
				break;
				case "NK_KB_left": KB_CursorLeft(); keydone = true; break;
				case "NK_KB_right": KB_CursorRight(); keydone = true; break;
				case "NK_KB_del": KB_DeleteCharacter(); keydone = true; break;
				case "NK_KB_ins": bKeyboardOverwriteMode = !bKeyboardOverwriteMode; KB_AddCharacter(""); keydone = true; break;
				case "NK_KB_home": KB_CursorHome(); keydone = true; break;
				case "NK_KB_end": KB_CursorEnd(); keydone = true; break;
// <-- KK
				case "NK_KB_back": KB_RemoveCharacter(); keydone = true; break;
				case "NK_KB_esc": KeyboardString = ""; event("KB_End"); update = false; break;
				case "NK_KB_enter": event("KB_End"); update = false; break;
			}
		}
		if(update) event("KB_update");
		return;
	}

// TIH --> moved chunk out of switch case limbo to here 7-7-06
	string leftAnimation, rightAnimation;
	if(StraifCharacter(PChar))
	{
		if(LAi_IsFightMode(PChar))
		{
			leftAnimation = "straif_weapon_left";
			rightAnimation = "straif_weapon_right";
		}
		else
		{
			leftAnimation = "straif_left";
			rightAnimation = "straif_right";
		}
	}
// TIH <-- moved chunk

	string newitm, logstr; // KK
	switch(ControlName)
	{
		// Scheffnow -->
		case "SCHEFFNOW_RUSH":
			if(dialogRun || dialogSelf || CheckAttribute(PChar,"paused")) break;//MAXIMUS
			if(CheckCharacterPerk(PChar,"Rush"))
			{
				ActivateCharacterPerk(PChar,"Rush");
			}
		break;
		// scheffnow <--

		// NK -->
		// 05-07-13 Pause
		case "NK_Pause":
			if(!CheckAttribute(PChar, "paused")) { LaunchPause(); }//MAXIMUS: unused now, so will be used for PAUSE ;)
			else { PostEvent("exitCancel", 0); }
		break;

		// 05-07-13 separate dialog key
		case "NK_DialogStart":
			if(CORPSEMODE!=2) break;//MAXIMUS: only CORPSEMODE = 2 makes a lootable corpses
			if(dialogRun || dialogSelf || CheckAttribute(PChar,"paused")) break;//MAXIMUS

			// if(bSeaActive && !bAbordageStarted) use that?
			if(FindLoadedLocation() != -1 && !sti(Interfacestates.Launched))
			{
				int tmpi = SendMessage(GetMainCharacter(),"ls",MSG_CHARACTER_EX_MSG,"FindDialogCharacter");
// changed by MAXIMUS [now we are looting corpses without dialog file] -->
				ref chCorpse, lcn;
				//aref chCorpse;
// added by MAXIMUS 21.07.2006 [corpses without any items and money will not be looted] -->
				aref testItems;
				string itmName = "";
				int it;
// added by MAXIMUS 21.07.2006 [corpses without any items and money will not be looted] <--
				// TIH: Do once, not copy/pasted many times Sep3'06
				if(tmpi<0) { tmpi = LAi_FindNearestVisCharacter(PChar, 20); }
				if(tmpi>=0)
				{					
					chCorpse = GetCharacter(tmpi);
					if(CheckAttribute(chCorpse,"corpse")==true)
					{
						if(chCorpse.dialog.filename == "corpse_dialog.c")
						// PB: To enable talking to corpses that don't have corpse_dialog.c set
						{
							// changed by MAXIMUS 21.07.2006 [corpses without any items and money will not be looted] -->
							if(!CheckAttribute(chCorpse,"Money")) chCorpse.Money = 0;
							DeleteAttribute(chCorpse,"Items.bladeX4");
							makearef(testItems,chCorpse.items);
							for(it=0; it<GetAttributesNum(testItems); it++)
							{
								itmName = GetAttributeName(GetAttributeN(testItems,it));
								if(GetCharacterItem(chCorpse,itmName)==0) DeleteAttribute(chCorpse,"Items."+itmName);
							}
							if(GetAttributesNum(testItems)==0 && sti(chCorpse.Money)==0) Log_SetStringToLog(TranslateString("","NoItems"));
							else
							{
								PlaySound("OBJECTS\shipcharge\sail_damage1.wav");
								bDeadExchange = true;
								LaunchCharacterItemChange(chCorpse);
							}
							// changed by MAXIMUS 21.07.2006 [corpses without any items will not be looted] <--
							lcn = &Locations[FindLocation(chCorpse.location)];
						//	if(CheckAttribute(lcn,"building") || CORPSEMODE < 2)
							if(CheckAttribute(lcn,"building") || CORPSEMODE < 3) // TIH lootable corpses adjustment Sep2'06
							{
								LAi_SetImmortal(chCorpse, false);
								ChangeCharacterAddressGroup(chCorpse, "None", "", "");
								PostEvent("RemoveCorpse", 100, "i", chCorpse);
							}
						}
						else
						{
							PChar.forcedlg = true;
							Event("dlgReady","l",tmpi);
						}
					}
				}
				// TIH <--
// changed by MAXIMUS [now we are looting corpses without dialog file] <--
			}

		break;

		case "ScreenCleaning":
			if(dialogRun || dialogSelf || CheckAttribute(PChar,"paused")) break;//MAXIMUS
// KK -->
			ShowScreen = !ShowScreen;
			if (bSeaActive && !bAbordageStarted)
				BIVisible(ShowScreen);
			else
				BLIVisible(ShowScreen);
// <-- KK
		break;

		case "NK_Re-init": Reinit(false, true); break;

		case "NK_AlwaysRunToggle":
			if (!bSeaActive || bAbordageStarted)
			{
				AlwaysRunToggle = !AlwaysRunToggle;
				BeginChangeCharacterActions(GetMainCharacter()); // NK 04-09-17 have it change now.
				SetDefaultNormWalk(GetMainCharacter());
				SetDefaultFight(GetMainCharacter());
				EndChangeCharacterActions(GetMainCharacter()); // NK ditto
				if(AlwaysRunToggle) Log_SetStringToLog(TranslateString("","Always run is now on"));
				else Log_SetStringToLog(TranslateString("","Always run is now off"));
			}
			else
			{
				if(sti(GetAttribute(GetMainCharacter(), "clubhauling")) == 1 )
				{
					Characters[GetMaincharacterIndex()].clubhauling = -1;
					LogIt("Clubhauling default direction set to PORT");
				}
				else
				{
					Characters[GetMaincharacterIndex()].clubhauling = 1;
					LogIt("Clubhauling default direction set to STARBOARD");
				}
			}
		break;

		case "NK_LogsToggle":
			LogsToggle = !LogsToggle;
			if(LogsToggle) Log_SetStringToLog(TranslateString("","Various logs are now on")); //bugfix 04-08-28
			else Log_SetStringToLog(TranslateString("","Various logs are now off"));
		break;

		case "executeconsole":
			if(LoadSegment("console.c"))
			{
				ExecuteConsole();
				UnloadSegment("console.c");
			}
		break;
// added by MAXIMUS [for new C-III models, which have an animated sidestep] -->
		case "Sidestep_left_on":
			if(StraifCharacter(PChar) && CheckAttribute(PChar,"location") && FindLocation(PChar.location)!=-1) 
			{
				CharacterPlayAction(PChar, leftAnimation); 
				SideStepControl(-STRAIF_DIST, true);
				PostEvent("Lai_EndAction", 250, "i", PChar);
			}
			else 
			{ 
				if(FindLoadedLocation()!=-1) SideStepControl(-SIDESTEP_DIST, true);
			}
		break;
		case "Sidestep_right_on":
			if(StraifCharacter(PChar) && CheckAttribute(PChar,"location") && FindLocation(PChar.location)!=-1) 
			{
				CharacterPlayAction(PChar, rightAnimation); 
				SideStepControl(STRAIF_DIST, true);
				PostEvent("Lai_EndAction", 250, "i", PChar);
			}
			else 
			{ 
				if(FindLoadedLocation() != -1) SideStepControl(SIDESTEP_DIST, true);
			}
		break;
		case "Sidestep_left_off": 
			if(!StraifCharacter(PChar)) SideStepControl(SIDESTEP_DIST, false);
		break;
		case "Sidestep_right_off": 
			if(!StraifCharacter(PChar)) SideStepControl(SIDESTEP_DIST, false);
		break;
// added by MAXIMUS [for new C-III models, which have an animated sidestep] -->

		// JRH -->
		case "ChrFightMode":
		    if(CheckAttribute( &Locations[FindLocation(GetAttribute(Pchar, "location"))],"noFight" ))
		    {
				//do nothing of this
		    }
		    else
		    {
				string weaponID = GetCharacterEquipByGroup(Pchar,GUN_ITEM_TYPE);
				aref weapon;
				Items_FindItem(weaponID, &weapon);

				float charge = stf(Pchar.chr_ai.charge);

				if(LAi_IsFightMode(PChar))
				{
					//Log_SetStringToLog("BUTTON FIGHTMODE OFF");

					if(IsEquipCharacterByItem(Pchar, "pistolmtoon"))
					{
						if(CheckAttribute(weapon,"model") && weapon.model == "musketoon")
						{
							if(charge <= 0.0) Pchar.quest.mtoon_status = "unloaded";

							LAi_QuestDelay("place_mtoon_on_back", 2.0);
						}
					}

					if(IsEquipCharacterByItem(Pchar, "pistolmket"))
					{
						if(CheckAttribute(weapon,"model") && weapon.model == "musket")
						{
							if(charge <= 0.0) Pchar.quest.mket_status = "unloaded";

							LAi_QuestDelay("place_mket_on_back", 2.0);
						}
					}
				}
				else
				{
					//Log_SetStringToLog("BUTTON FIGHTMODE ON");

					if(IsEquipCharacterByItem(Pchar, "pistolmtoon"))
					{
						if(charge == 1.0) LAi_QuestDelay("place_mtoon_on_hip", 1.0);
					}

					if(IsEquipCharacterByItem(Pchar, "pistolmket"))
					{
						if(charge == 1.0) LAi_QuestDelay("place_mket_on_hip", 1.0);
					}
				}
		    }
		break;
		// <-- JRH

		// PB: Equip button -->
		case "Equip":
			if(dialogRun || dialogSelf || CheckAttribute(PChar,"paused")) break;//MAXIMUS
			if(bSeaActive && !bAbordageStarted) break; // PB: Don't do this while sailing, but don't prevent it during boarding
			// NK last edit 28-05-06; PB last edit 05-10-06
			// set up strings
			logstr = "";
			string errstr = "";

			// blade
			string olditm = GetCharacterEquipByGroup(&PChar, BLADE_ITEM_TYPE);
			newitm = FindCharacterItemByGroup(&PChar, BLADE_ITEM_TYPE);

			// TIH --> fixed equipping of swords for NON blade damage mod toggle Aug29'06
			// using quality is not needed, and gets in the way if you had a higher quality low sword equipped
			// even though you had a low quality higher sword in your inventory
			// if BLADEDAMAGE_ENABLED is ON, then it uses quality checks
			
			//int olditmqual = GetItemQualityByID(olditm); // TIH quality now checked when finding a valid new item
			//int newitmqual = GetItemQualityByID(newitm);
			if(newitm != olditm && newitm != "")
			{
				switch(GetItemQualityByID(newitm))
				{
					case 0: logstr += TranslateString("","a badly worn") + " "; break;
					case 1: logstr += TranslateString("","a worn") + " "; break;
					case 2: logstr += TranslateString("","an average") + " "; break;
					case 3: logstr += TranslateString("","a good") + " "; break;
					case 4: logstr += TranslateString("","a fine") + " "; break;
					case 5: logstr += TranslateString("","an excellent") + " "; break;
					// default:
					logstr += TranslateString("","a") + " ";
				}
				logstr += GetItemNameByID(newitm);
				EquipCharacterByItem(&PChar, newitm);
			}
			if(newitm == "" || newitm == "bladeX4")
			{
				errstr = XI_ConvertString("a sword");
			}

			/* older method
			int olditmqual = GetItemQualityByID(olditm);
			int newitmqual = GetItemQualityByID(newitm);
			bool shownoqual = false;
			if(newitmqual == -1)
			{
				newitmqual = 5;
				shownoqual = true;
			}
			if(newitm != olditm && newitmqual >= olditmqual && newitmqual != 0) // PB: Don't ever auto-equip broken blades
			{
				if(shownoqual)
				{
					if(newitm != "bladeX4") {logstr += XI_ConvertString("a")+" ";}
					shownoqual = false;
				}
				else
				{
					switch(newitmqual)
					{
						case 0: logstr += TranslateString("","a broken") + " "; break; // This line should never be used
						case 1: logstr += TranslateString("","a worn") + " "; break;
						case 2: logstr += TranslateString("","an average") + " "; break;
						case 3: logstr += TranslateString("","a good") + " "; break;
						case 4: logstr += TranslateString("","a fine") + " "; break;
						case 5: logstr += TranslateString("","an excellent") + " "; break;
					}
				}
				logstr += GetItemNameByID(newitm);
				EquipCharacterByItem(&PChar, newitm);
			}
			if(newitm == "" || newitm == "bladeX4") { errstr = XI_ConvertString("a sword"); }
			*/
			// TIH <--

			// gun
			olditm = GetCharacterEquipByGroup(&PChar, GUN_ITEM_TYPE);
			newitm = FindCharacterItemByGroup(&PChar, GUN_ITEM_TYPE);

			// TIH --> fixed equipping of guns Aug24'06
			// using quality is not needed, and gets in the way if you had a higher quality low gun equipped 
			// even though you had a low quality higher gun in your inventory
			if(newitm != olditm && newitm != "")
			{
				if(logstr != "") logstr += " " + XI_ConvertString("and") + " ";
				switch(GetItemQualityByID(newitm))
				{
					case 0: logstr += TranslateString("","a badly worn") + " "; break;
					case 1: logstr += TranslateString("","a worn") + " "; break;
					case 2: logstr += TranslateString("","an average") + " "; break;
					case 3: logstr += TranslateString("","a good") + " "; break;
					case 4: logstr += TranslateString("","a fine") + " "; break;
					case 5: logstr += TranslateString("","an excellent") + " "; break;
					// default:
					logstr += TranslateString("","a") + " ";
				}
				logstr += GetItemNameByID(newitm);
				EquipCharacterByItem(&PChar, newitm);
			}
			if(newitm == "")
			{
				if(errstr != "") errstr += " " + XI_ConvertString("or") + " ";
				errstr += XI_ConvertString("a gun");
			}
			// TIH <--
			/* older method, which sort of broke a bit
			olditmqual = GetItemQualityByID(olditm);
			newitmqual = GetItemQualityByID(newitm);

			if(newitmqual == -1)
			{
				newitmqual = 5;
				shownoqual = true;
			}

			if(newitm != olditm && newitmqual >= olditmqual)
			{
				if(logstr != "") logstr += " " + XI_ConvertString("and") + " ";

				if(shownoqual)
				{logstr += XI_ConvertString("a")+" ";}
				else
				{
					switch(newitmqual)
					{
						case 0: logstr += TranslateString("","a badly worn") + " "; break;
						case 1: logstr += TranslateString("","a worn") + " "; break;
						case 2: logstr += TranslateString("","an average") + " "; break;
						case 3: logstr += TranslateString("","a good") + " "; break;
						case 4: logstr += TranslateString("","a fine") + " "; break;
						case 5: logstr += TranslateString("","an excellent") + " "; break;
					}
				}

				logstr += GetItemNameByID(newitm);
				EquipCharacterByItem(&PChar, newitm);
			}
			else
			{
				if(newitm == "")
				{
					if(errstr != "") errstr += " " + XI_ConvertString("or") + " ";
					errstr += XI_ConvertString("a gun");
				}
			}
			*/

			// glass
			olditm = GetCharacterEquipByGroup(&PChar, SPYGLASS_ITEM_TYPE);
			newitm = FindCharacterItemByGroup(&PChar, SPYGLASS_ITEM_TYPE);

			if(newitm != olditm && newitm != "")
			{
				if(logstr != "") logstr += " " + XI_ConvertString("and") + " ";
				logstr += XI_ConvertString("a")+" " + GetItemNameByID(newitm);
				EquipCharacterByItem(&PChar, newitm);
			}
			if(newitm == "")
			{
				if(errstr != "") errstr += " " + XI_ConvertString("or") + " ";
				errstr += XI_ConvertString("a spyglass");
			}

			// armor
			olditm = GetCharacterEquipByGroup(&PChar, ARMOR_ITEM_TYPE);
			newitm = FindCharacterItemByGroup(&PChar, ARMOR_ITEM_TYPE);
			if(olditm != newitm && newitm != "" && newitm != "cheaparmor")
			{
				if(logstr != "") logstr += " " + XI_ConvertString("and") + " ";
				logstr += GetItemNameByID(newitm);
				EquipCharacterByItem(&PChar, newitm);
			}
			if(newitm == "")
			{
				if(errstr != "") errstr += " " + XI_ConvertString("or") + " ";
				errstr += XI_ConvertString("any armor");
			}
		
		if (ENABLE_AMMOMOD)
		{// TIH --> mod toggle Jul15'06
		//JRH ammo mod start
			// powderflask
			olditm = GetCharacterEquipByGroup(&PChar, FLASK_ITEM_TYPE);
			newitm = FindCharacterItemByGroup(&PChar, FLASK_ITEM_TYPE);

			if(newitm != olditm && newitm != "")
			{
				if(logstr != "") logstr += " " + XI_ConvertString("and") + " ";
				logstr += XI_ConvertString("a Powder Flask");
				EquipCharacterByItem(&PChar, newitm);
			}
			if(newitm == "")
			{
				if(errstr != "") errstr += " " + XI_ConvertString("or") + " ";
				errstr += XI_ConvertString("s"+"a powder flask");
			}

			// ammopouch
			olditm = GetCharacterEquipByGroup(&PChar, POUCH_ITEM_TYPE);
			newitm = FindCharacterItemByGroup(&PChar, POUCH_ITEM_TYPE);

			if(newitm != olditm && newitm != "")
			{
				if(logstr != "") logstr += " " + XI_ConvertString("and") + " ";
				logstr += XI_ConvertString("an Ammunition Pouch");
				EquipCharacterByItem(&PChar, newitm);
			}
			if(newitm == "")
			{
				if(errstr != "") errstr += " " + XI_ConvertString("or") + " ";
				errstr += XI_ConvertString("s"+"an ammunition pouch");
			}
		// JRH -->
			int gp = GetCharacterItem(Pchar, "gunpowder");
			int pb = GetCharacterItem(Pchar, "pistolbullets");
			if(gp == 0)
			{
				//TakenItems(Pchar, "gunpowder", 1); //TakenItems(Pchar, "gunpowder", -1);
				DeleteAttribute(Pchar,"Items.gunpowder");
			}
			if(pb == 0)
			{
				//TakenItems(Pchar, "pistolbullets", 1); //TakenItems(Pchar, "pistolbullets", -1);
				DeleteAttribute(Pchar,"Items.pistolbullets");
			}
		// <-- JRH
		//JRH ammo mod end
		}// TIH <-- mod toggle

			// output
			if(logstr != "") { Logit(TranslateString("","You equipped") + " " + logstr + "."); }
			if(errstr != "") { Logit(TranslateString("","You don't have") + " " + errstr + " " + TranslateString("","to equip") + "."); }
		break;
		// PB: Equip button <--

		// PB: Steam Ships -->
		case "Ship_PowerUp":
			if(SteamShip(PChar) && bSeaActive && !bAbordageStarted)
			{
				PChar.Ship.Power = sti(GetAttribute(PChar,"Ship.Power")) + 25;
				if(sti(PChar.Ship.Power) > 100) PChar.Ship.Power = 100;
			}
		break

		case "Ship_PowerDown":
			if(SteamShip(PChar) && bSeaActive && !bAbordageStarted)
			{
				PChar.Ship.Power = sti(GetAttribute(PChar,"Ship.Power")) - 25;
				if(sti(PChar.Ship.Power) < -100) PChar.Ship.Power = -100;
			}
		break

		case "Ship_PowerZero":
			if(SteamShip(PChar) && bSeaActive && !bAbordageStarted)
			{
				PChar.Ship.Power = 0;
			}
		break
		// PB: Steam Ships <--

		// El Rapido Rapid Raid -->
		case "Rapid_Raid":
			if(dialogRun || dialogSelf || CheckAttribute(PChar,"paused")) break;//MAXIMUS
			PlaySound("OBJECTS\raid.wav");
			if(Pchar.nation != FRANCE)
			{
				Rapid_Raid("soldiers", "none", 10, FRANCE, "friend", "enemy","A French infantry unit suddenly appears and attacks you!", "French Musketeer", 8, 4, 120, 360, 9, 9, 0, 80, 4, 20);
			}
			else
			{
				Rapid_Raid("soldiers", "none", 10, SPAIN, "friend", "enemy","Several Conquistadores attack you!", "Conquistador", 9, 5, 180, 400, 14, 6, 0, 100, 4, 30);
			}
		break;
		// El Rapido Rapid Raid <--
			
		// NK <--
		// TIH -->
		case "TIH_FireDrill":
			// ccc firedrill properly added under its own key now -tih
			if(dialogRun || dialogSelf || CheckAttribute(PChar,"paused")) break;//MAXIMUS
			if (!IsPerkIntoList("FireOnShip")) break; // KK
			ref mch = GetMainCharacter();

			// ccc firedrill
 			if(bSeaActive == true && bAbordageStarted == false && FIREDAMAGE > 1) { // checks if you are in sailing mode MAR18
				Log_SetStringToLog(TranslateString("","All hands execute fire drill ! NOW !!")); // just a screenmessage
				if (FD_REQUIRE_DEFENSE == 0 || CheckOfficersPerk(mch,"BasicBattleState")) {
					// starts firedrill only if you have shipdefense ability
					// or this check is turned off in BS.h -tih
					mch.firedrill = 1; // adds attribute to player as "marker" that firedrill is ordered
					if (IsPerkIntoList("FireOnShip")) DelPerkFromActiveList("FireOnShip"); // KK
					PlaySound("clear_for_action"); // just soundeffect
					PlaySound("objects\abordage\abordage_loosing.wav");
					Ship_SetSailState(GetMainCharacterIndex(), 0.0); // smoldering sails jettisoned MAR18 NK uses index not ref. 05-04-20
					if (GUN_DOUSING == 1) {
						Ship_ChangeCharge(mch, sti(mch.Ship.Cannons.Charge.Type)); // cartridges jettisoned MAR18
						Log_SetStringToLog(TranslateString("","Sails and cartridges jettisoned.")); // MAR18
					}
				} else {
					Log_SetStringToLog(TranslateString("","Captain, what's a firedrawl?"));	// just a screenmessage
					Log_SetStringToLog(TranslateString("","Your crew seems to lack the SHIP DEFENSE ability..."));	// just a screenmessage
					PlaySound("VOICE\" + LanguageGetLanguage() + "\Eng_m_b_079.wav");	// just soundeffect
				}
			}
			// ccc firedrill end, original potion-use mod put with its original key -tih
		break;
		// TIH <--

		// boal -->
		case "BOAL_UsePotion":
			if(dialogRun || dialogSelf || CheckAttribute(PChar,"paused")) break;//MAXIMUS
			if (LAi_GetCharacterHP(PChar) >= LAi_GetCharacterMaxHP(PChar)) break; // KK
			int idx = -1;
			if(USEMAXPOTION_ONKEYPRESS)
			{
				MaxHealthPotionForCharacter(PChar, &idx);
			}
			else
			{
				MinHealthPotionForCharacter(PChar, &idx);
			}
			if(idx != -1)
			{
				DoCharacterUsedItem(PChar, Items[idx].id);
				Log_SetStringToLog(TranslateString("","Used potion"));
			}
			// NK <--
		break;

		// PB: Simplified Time Compression Controls -->
		case "BOAL_Control":
			if(dialogRun || dialogSelf || CheckAttribute(PChar,"paused")) break;//MAXIMUS
			if(CheckAttribute(PChar,"basetime"))	basetime = stf(PChar.basetime);
			else									PChar.basetime = 1.0;

			AddPerkToActiveList("TimeSpeed");
			switch(sti(PChar.basetime))
			{
				case  0: PChar.basetime =  1; break;
				case  1: PChar.basetime =  3; break;
				case  3: PChar.basetime = 10; break;
				case 10: PChar.basetime = 30; break;
			}
			SetTimeScale(sti(PChar.basetime));
			LogIt(XI_ConvertString("Time") + " x" + PChar.basetime);
		break;

		case "BOAL_Control0":
			if(dialogRun || dialogSelf || CheckAttribute(PChar,"paused")) break;//MAXIMUS
			if(CheckAttribute(PChar,"basetime"))	basetime = stf(PChar.basetime);
			else									PChar.basetime = 1.0;

			switch(sti(PChar.basetime))
			{
				case 30: PChar.basetime = 10; break;
				case 10: PChar.basetime =  3; break;
				case  3: PChar.basetime =  1;
						 DelPerkFromActiveList("TimeSpeed"); break;
			}
			SetTimeScale(sti(PChar.basetime));
			LogIt(XI_ConvertString("Time") + " x" + PChar.basetime);
		break;
		// PB: Simplified Time Compression Controls <--

		case "BOAL_Control2":
// changed by MAXIMUS [just for fun] -->
			int res = SendMessage(PChar,"ls",MSG_CHARACTER_EX_MSG,"FindDialogCharacter");//LAi_FindNearestVisCharacter(PChar, 20);
			ref findCh;
			if (res>0)//if(res != -1)
			{
				findCh = GetCharacter(res);
				if(!CheckAttribute(findCh, "corpse"))
				{
					//res = findCh.chr_ai.hp;
					LaunchOfficer(findCh);
				//Log_SetStringToLog(XI_ConvertString("You see") + " " + findCh.name + " " + findCh.lastname + " " + XI_ConvertString("Fencing") + " " + findCh.skill.Fencing + " " + XI_ConvertString("HP") + " " + res );
// changed by MAXIMUS [just for fun] <--
				}
			}
		break;

// dchaley -->
		case "DCH_Quicksave":
			DoQuickSave();
		break;

		case "DCH_Quickload":
			DoQuickLoad();
		break;

		case "Sulan_ArchipelagoMap":
			if(CheckCharacterItem(PChar,"map")) 
			{
				LaunchPelagoMap();
			}
			else
			{
				LogIt("You don't have a map of the archipelago.");
			}
		break;
// dchaley <--
	}
// boal <--

// ccc special weapons, equip by hotkey  
	
	if(!bSeaActive || bAbordageStarted)
	{
		switch(ControlName)
		{
		case "BI_ChargeCannonballs":
		// PB: Equip [Regular Blade]
			if(CheckCharacterItem(Pchar,FindCharacterItemByGroup(&PChar, BLADE_ITEM_TYPE)))
			{
// KK -->
				newitm = FindCharacterItemByGroup(PChar, BLADE_ITEM_TYPE);
				EquipCharacterByItem(&PChar, newitm);
				logstr = GetItemQualityName(GetItemQualityByID(newitm));
				if (logstr == "")
					logstr = " ";
				else
					logstr = " " + logstr + " ";
				Logit(TranslateString("","You equipped") + logstr + GetItemNameByID(newitm) + ".");
// <-- KK
			} else {
				Logit(TranslateString("","You don't have a regular blade to equip."));
			}
			break;

		case "BI_ChargeGrapes":
		// PB: Equip [Regular Gun]
			if(CheckCharacterItem(Pchar,FindCharacterItemByGroup(&PChar, GUN_ITEM_TYPE)))
			{
// KK -->
				newitm = FindCharacterItemByGroup(PChar, GUN_ITEM_TYPE);
				EquipCharacterByItem(&PChar, newitm);
				logstr = GetItemQualityName(GetItemQualityByID(newitm));
				if (logstr == "")
					logstr = " ";
				else
					logstr = " " + logstr + " ";
				Logit(TranslateString("","You equipped") + logstr + GetItemNameByID(newitm) + ".");
// <-- KK
			} else {
				Logit(TranslateString("","You don't have a regular gun to equip."));
			}
			break;

		case "BI_ChargeKnippels":
		// PB: Equip [Cobblestone]
			if(CheckCharacterItem(Pchar,"pistolrock"))
			{
				EquipCharacterByItem(&PChar, "pistolrock");
				Logit(TranslateString("","You equipped a cobblestone."));
			}
			else
			{Logit(TranslateString("","You don't have a cobblestone to equip."));}
			break;

		case "BI_ChargeBombs":
		// PB: Equip [Sandbag]
			if(CheckCharacterItem(Pchar,"bladeX2"))
			{
				EquipCharacterByItem(&PChar, "bladeX2");
				Logit(TranslateString("","You equipped a sandbag."));
			}
			else
			{Logit(TranslateString("","You don't have a sandbag to equip."));}
			break;

		// PB: More fast equip keys -->
		case "BI_ChargeKey5":
		// PB: Equip [Etherbottle]
			if(CheckCharacterItem(Pchar,"pistolgas"))
			{
				EquipCharacterByItem(&PChar, "pistolgas");
				Logit(TranslateString("","You equipped an etherbottle."));
			}
			else
			{Logit(TranslateString("","You don't have an etherbottle to equip."));}
			break;

		case "BI_ChargeKey6":
		// PB: Equip [Thief's Knife]
			if(CheckCharacterItem(Pchar,"bladeX3"))
			{
				EquipCharacterByItem(&PChar, "bladeX3");
				Logit(TranslateString("","You equipped a thief's knife."));
			}
			else
			{Logit(TranslateString("","You don't have a thief's knife to equip."));}
			break;

		case "BI_ChargeKey7":
		// PB: Equip [Poisoned Throwingknife]
			if(CheckCharacterItem(Pchar,"pistolpdart"))
			{
				EquipCharacterByItem(&PChar, "pistolpdart");
				Logit(TranslateString("","You equipped a poisoned throwingknife."));
			}
			else
			{Logit(TranslateString("","You don't have a poisoned throwingknife to equip."));}
			break;

		case "BI_ChargeKey8":
		// PB: Equip [Stinkpot]
			if(CheckCharacterItem(Pchar,"pistolstink"))
			{
				EquipCharacterByItem(&PChar, "pistolstink");
				Logit(TranslateString("","You equipped a stinkpot."));
			}
			else
			{Logit(TranslateString("","You don't have a stinkpot to equip."));}
			break;

		case "BI_ChargeKey9":
		// PB: Equip [Grenade]
			if(CheckCharacterItem(Pchar,"pistolgrenade"))
			{
				EquipCharacterByItem(&PChar, "pistolgrenade");
				Logit(TranslateString("","You equipped a grenade."));
			}
			else
			{Logit(TranslateString("","You don't have a grenade to equip."));}
			break;

		case "BI_ChargeKey0":
		// PB: Equip [Your Trusty Fists]
			if(CheckCharacterItem(Pchar,"bladeX4"))
			{
				EquipCharacterByItem(&PChar, "bladeX4");
				Logit(TranslateString("","You equipped your trusty fists."));
			}
			else
			{Logit(TranslateString("","What the heck? You don't have your trusty fists???"));}
			break;
		// PB <--
// KK -->
		case "ChrActionAlt":
			int dlgchk = SendMessage(GetMainCharacter(), "ls", MSG_CHARACTER_EX_MSG, "FindDialogCharacter");
			if (dlgchk >= 0) {
				Event("dlgReady", "l", dlgchk);
			} else {
				if (g_ActiveActionName != "Nothing") {
					Event("BI_FastCommand", "s", g_ActiveActionName);
				} else {
					if (bAbordageStarted) {
						Event("Control Activation", "s", "ChrAction");
					}
				}
			}
			break;

		case "DlgActionAlt":
			SwitchDialogControls();
			break;

		case "DlgUpAlt":
			SwitchDialogControls();
			break;

		case "DlgDownAlt":
			SwitchDialogControls();
			break;
// <-- KK
		}
	}	
	ProcessCCCkeys(ControlName);  // ccc Jan07, for Directsail and mines
// ccc end

// KK -->
	if (sti(InterfaceStates.Launched) == true) {
		int clicktimedlt = 0;
		switch (ControlName) {
			case "ILClick":
				bLMouseDown = true;
				iLMouseClickCnt++;
				if (iLMouseClickCnt == 1) {
					iLMouseClickTime = sti(InterfaceStates.GameTime.sec);
					sLClickedNode = GetCurrentNode();
					PostEvent("evntMouseBtnClickCheck", 1.0, "l", 0);
				}
			break;
			case "ILClick_Up":
				bLMouseDown = false;
			break;
			case "IRClick":
				bRMouseDown = true;
				iRMouseClickCnt++;
				if (iRMouseClickCnt == 1) {
					iRMouseClickTime = sti(InterfaceStates.GameTime.sec);
					sRClickedNode = GetCurrentNode();
					PostEvent("evntMouseBtnClickCheck", 1.0, "l", 1);
				}
			break;
			case "IRClick_Up":
				bRMouseDown = false;
			break;
		}
	}
// <-- KK

	
	if(bSeaActive && !bAbordageStarted)
	{
		switch(ControlName)
		{
			case "MainMenu": ProcessMainMenuKey();	break;
			case "MainMenuDouble": ProcessMainMenuKey(); break;
			case "Interface": ProcessInterfaceKey();break;

			case "Sea_CameraSwitch": SeaCameras_Switch(); break;
			case "Ship_Fire": Ship_DoFire(); break;

			case "Aimed_Ship_Fire": Ship_DoAimedFire(); break;	// LDH - allows manual aiming
			//case "Tele": Sea_ReloadStart(); break;

// KK -->
			case "ILeft":
				if (bKeyboardControl) SeaCameras_SetPreviousShip();
			break;
			case "IRight":
				if (bKeyboardControl) SeaCameras_SetNextShip();
			break;
			case "IDown":
				if (bKeyboardControl) SeaCameras_SetMyShip();
			break;
			case "ControlDown": bKeyboardControl = true; break;
			case "ControlUp": bKeyboardControl = false; break;
// <-- KK
		}
	}
	else
	{
		switch(ControlName)
		{
			case "MainMenu": ProcessMainMenuKey();	break;
			case "MainMenuDouble": ProcessMainMenuKey(); break;
			case "Interface": ProcessInterfaceKey();break;
			case "Tele":
				StartQuickTeleport();
				break;
			case "TeleBack": Teleport(-1); break;
			case "Action":
				//DumpAttributes(loadedLocation/*loadedLocation.reload.reload1.x*/);
				//trace("Y: " + loadedLocation.reload.reload1.y);
				//trace("Z: " + loadedLocation.reload.reload1.z);
			break;
		}
	}


	/*switch(ControlName)
	{
		counter++;
		if(counter > 3) counter = 0;
		case "CameraSwitch":
			switch(counter)
			{
			case 0: SetDayTime(DAY_TIME_NIGHT); break;
			case 1: SetDayTime(DAY_TIME_MORNING); break;
			case 2: SetDayTime(DAY_TIME_DAY); break;
			case 3: SetDayTime(DAY_TIME_EVENING); break;
			}
		break;
	}*/
}

// added by MAXIMUS -->
bool StraifCharacter(ref chr)
{
	if(!CheckAttribute(chr,"model")) return false;
	if(GetModelIndex(chr.model)==-1) return false;
	aref ourModel; makearef(ourModel,Models[GetModelIndex(chr.model)]);
	if(CheckAttribute(ourModel,"status") && ourModel.status=="C_III")
	{
		return true;
	}
	return false;
}

#event_handler("Lai_EndAction", "Lai_ReturnNormal");
void Lai_ReturnNormal()
{
	aref chr = GetEventData();
	CharacterPlayAction(chr, "");
	SideStepControl(-STRAIF_DIST, false);
	SideStepControl(STRAIF_DIST, false);
}
#event_handler("RemoveCorpse", "Lai_KillCorpse");
void Lai_KillCorpse()
{
	aref chCorpse = GetEventData();
	Lai_KillCharacter(chCorpse);
}
// added by MAXIMUS <--

void Teleport(int step)
{
	nTeleportLocation = nTeleportLocation + step;
	if(nTeleportLocation >=	nLocationsNum) nTeleportLocation = 1;
	if(nTeleportLocation <=	0) nTeleportLocation = nLocationsNum - 1;

	sTeleportLocName = Locations[nTeleportLocation].id;
	Trace("Teleport to '" + sTeleportLocName + "'");

	ReleaseSound(0);
	ClearEvents();
	ClearPostEvents();
	DeleteEntities();
	SetEventHandler("frame","NewGame",1);
}

void ProcessMainMenuKey()
{
	LaunchMainMenu();
}

void ProcessInterfaceKey()
{
	if(bSeaActive && !bAbordageStarted)
	{
		if( CheckAttribute(&BattleInterface,"ComState") && sti(BattleInterface.ComState) != 0 )
			{return;}
	}
	else
	{
		if( SendMessage(GetMainCharacter(),"ls",MSG_CHARACTER_EX_MSG,"IsFightMode") != 0 )
			{return;}
		if( CheckAttribute(&objLandInterface,"ComState") && sti(objLandInterface.ComState) != 0 )
			{return;}
	}
	if( IsEntity(&worldMap) ) return;
//	LaunchSelectMenu(); // MAXIMUS interface MOD
	LaunchCharacter(GetMainCharacter()); // MAXIMUS interface MOD
}

//ccc survival ->
void GameOverE()
{
	ref mc = GetMainCharacter();
	if(rand(100) + (sti(mc.skill.Sneak)*3) > DEATHRATE)	// BF mar05
	{	//ccc new survival section
// KK
		if (HasSubStr(mc.ship.type, "Tartane") == true || mc.ship.type == "Gunboat") {
			GameOverOrg("sea");
			DeleteSeaEnvironment();
			return;
		}
// <-- KK
		Event("DoInfoShower","sl","MainMenuLaunch",true);	//TIH - black out the screen to hide uglyjunk
		LAi_SetCurHPMax(mc);
		mc.ship.type = "Tartane1";
		Ship_CreateForCharacter(mc, mc.Ship.Type, "Lifeboat");	// ccc apr03 // KK
// KK -->
		SetCharacterGoods(mc, GOOD_BALLS, 0);
		SetCharacterGoods(mc, GOOD_GRAPES, 0);
		SetCharacterGoods(mc, GOOD_KNIPPELS, 0);
		AddCharacterGoods(mc, GOOD_WHEAT, 2);
		AddCharacterGoods(mc, GOOD_RUM, 2);
// <-- KK
		mc.lifeboatlaunch = true;	//TIH - better check for when they sank
		Sea_ReloadStart();
		PostEvent("DoInfoShower",100,"s","");	//TIH - clears black screen
		PlaySound("ship_sinking");		//ccc mar20 // KK
		Log_SetStringToLog(TranslateString("","You manage to launch a boat in the last moment."));	//ccc mar20
		Log_SetStringToLog(TranslateString("","With a few mates you escape from disaster."));	//ccc mar20
	} else {	//ccc call original GameOver function
		GameOverOrg("sea");
		DeleteSeaEnvironment();
	}
}

void GameOver(string sName)
{
	if (bSuppressResurrection) return; // KK

	string loc = ""; // KK
	ref mc = GetMainCharacter(); // KK

// TIH --> process cleanup 7-7-06

	//ccc call original GameOver function / BF mar05
	if (rand(100) + (makeint(mc.skill.Sneak)*3) < DEATHRATE || CheckAttribute(mc,"killed")) { // SJG
		GameOverOrg(sName);
		return;
	}

	// TIH if die during boarding, you are DEAD
	if (sName == "boarding") {
		GameOverOrg(sName);
		return;
	}

	// TIH if mutiny, you are put to sea
	if (sName == "mutiny") {
		PlaySound("VOICE\"+LanguageGetLanguage()+"\Dut_m_a_054.wav");		//ccc mar20
		Log_SetStringToLog(XI_ConvertString("MUTINY") + "!");		//ccc mar20
		Log_SetStringToLog(TranslateString("","'Cap'n, we are giving you and your cronies this boat."));		//ccc mar20
		Log_SetStringToLog(TranslateString("","If you're careful, you just might make it."));		//ccc mar20
		Log_SetStringToLog(TranslateString("","But given your past performance you'll all starve!'"));		//ccc mar20
		GameOverE();
		return;
	}

	//MAXIMUS - if you die during fight with your crew
	if(CheckAttribute(mc,"mutiny"))
	{
		GameOverOrg("mutiny");
		DeleteAttribute(mc,"mutiny");
		return;
	}

//JRH -->
	//if rebirth NOT is possible during quest
	if(CheckAttribute(mc, "quest.disable_rebirth") && mc.quest.disable_rebirth == "yes")
	{
		GameOverOrg("land");
		//LanguageCloseFile(tmpLangFileID);
		return;
	}
//<-- JRH

	// TIH died in land fight, so you are resurrected somewhere
	//ccc new survival section
	string islandID;
// KK -->
	string TownID;
	int TownNation;

	Lai_SetActorType(mc);
	LAi_type_actor_Reset(mc);
	Lai_SetPlayerType(mc);

	if (CheckAttribute(mc, "location")) loc = mc.location;
	if (GetCharacterShipType(mc) != SHIP_NOTUSED) loc = GetCharacterShipLocation(mc);
	//if (CheckAttribute(Locations[FindLocation(loc)], "type") && Locations[FindLocation(loc)].type != "port" && CheckAttribute(Locations[FindLocation(loc)], "id") && !HasSubStr(Locations[FindLocation(loc)].id,"port")) loc = mc.location;//MAXIMUS
	if (loc == "") return;
	TownID = GetBestTown(loc);
	IslandID = GetIslandIDFromTown(TownID);
	TownNation = GetTownNation(TownID);

	if (mc.location.from_sea == "Muelle_shore_02") {
		mc.location.from_sea = "Muelle_port";
		PlaceFleetNearShore(mc.location.from_sea);
	}
// <-- KK

	//apply damage and losses
	// TIH --> new damage and losses code 7-8-06
	//mc.chr_ai.hp_max = makeint(sti(mc.chr_ai.hp_max) * 0.9);
	//mc.ship.hp = makeint(sti(mc.ship.hp) * rand(6)/10)+50;
	//mc.Ship.crew.quantity = makeint(sti(mc.Ship.crew.quantity) * rand(6)/10)+5;
	//mc.money = makeint(sti(mc.money) * rand(4)/10);
	// TIH <--

	string gun = GetCharacterEquipByGroup(&mc, GUN_ITEM_TYPE);
	RemoveCharacterEquip(mc, GUN_ITEM_TYPE);
	TakeItemFromCharacter(mc, gun);

	// PB: Keep your fists when you die -->
		if(GetCharacterEquipByGroup(&mc, BLADE_ITEM_TYPE) !="bladeX4")
		{
			string blade = GetCharacterEquipByGroup(&mc, BLADE_ITEM_TYPE);
			RemoveCharacterEquip(mc, BLADE_ITEM_TYPE);
			TakeItemFromCharacter(mc, blade);
		}
	// PB: Keep your fists when you die <--

	 //JRH: belt with or without any pistols (201-206) is lost too... -->
	mc.quest.reduce_ammo = "off";		//start mode

	if(IsEquipCharacterByItem(mc, "pistolbelt"))
	{
		if(IsEquipCharacterByItem(mc, "ammobag2"))
		{
			RemoveCharacterEquip(mc, POUCH_ITEM_TYPE);
		}
		
		if(CheckCharacterItem(mc, "ammobag2") || CheckCharacterItem(mc, "ammobag1"))
		{
			TakeItemFromCharacter(mc, "ammobag2");
			TakeItemFromCharacter(mc, "ammobag1");

			if(CheckAttribute(mc,"quest.reduce_ammo") && mc.quest.reduce_ammo == "off")
			{
				mc.quest.reduce_ammo = "on";
				LAi_QuestDelay("pistol_ranking_list", 0.1);
			}
		}

		RemoveCharacterEquip(mc, BELT_ITEM_TYPE);
		TakeItemFromCharacter(mc, "pistolbelt");

		if(!IsEquipCharacterByItem(mc, "bladepclub203"))
		{
			TakeItemFromCharacter(mc, "bladepclub203");	//unequipped
			if(!CheckCharacterItem(mc, "bladeX4")) 
			{
				GiveItem2Character(mc, "bladeX4");//if bladepclub203 instead
			}
		}

		if(IsEquipCharacterByItem(mc, "pistol201") || IsEquipCharacterByItem(mc, "pistol202") || IsEquipCharacterByItem(mc, "pistol203")
		|| IsEquipCharacterByItem(mc, "pistol204") || IsEquipCharacterByItem(mc, "pistol205") || IsEquipCharacterByItem(mc, "pistol206"))
		{
			RemoveCharacterEquip(mc, GUN_ITEM_TYPE);
		}

		TakeItemFromCharacter(mc, "pistol201"); TakeItemFromCharacter(mc, "pistol202"); TakeItemFromCharacter(mc, "pistol203");
		TakeItemFromCharacter(mc, "pistol204"); TakeItemFromCharacter(mc, "pistol205"); TakeItemFromCharacter(mc, "pistol206");

		if(CheckAttribute(mc,"model"))
		{
			//Only when quest is finished => dressed in red uniform + hat!
			if(mc.model == "ShkiperM_UH_b" || mc.model == "ShkiperM_UH_a")
			{
				SetModel(mc, "ShkiperM_UH", mc.model.animation, mc.sex, stf(mc.model.height), true);
			}
		}
	}

	//JRH loose pf, ap, pb or ab
		if(IsEquipCharacterByItem(mc, "ammopouch") || IsEquipCharacterByItem(mc, "ammobag"))
		{
			RemoveCharacterEquip(mc, POUCH_ITEM_TYPE);
			TakeItemFromCharacter(mc, "ammopouch"); TakeItemFromCharacter(mc, "ammobag");

			if(CheckCharacterItem(mc, "ammopouch") || CheckCharacterItem(mc, "ammobag1") || CheckCharacterItem(mc, "ammobag2") || CheckCharacterItem(mc, "ammobag"))
			{
				//fine
			}
			else
			{
				if(CheckAttribute(mc,"quest.reduce_ammo") && mc.quest.reduce_ammo == "off")
				{
					mc.quest.reduce_ammo = "on";
					LAi_QuestDelay("pistol_ranking_list", 0.1);
				}
			}
		}

		if(IsEquipCharacterByItem(mc, "powderflask") || IsEquipCharacterByItem(mc, "powderbarrel"))
		{
			RemoveCharacterEquip(mc, FLASK_ITEM_TYPE);
			TakeItemFromCharacter(mc, "powderflask"); TakeItemFromCharacter(mc, "powderbarrel");

			if(CheckCharacterItem(mc, "powderflask") || CheckCharacterItem(mc, "ammobag1") || CheckCharacterItem(mc, "ammobag2"))
			{
				//fine
			}
			else 
			{
				if(CheckAttribute(mc,"quest.reduce_ammo") && mc.quest.reduce_ammo == "off")
				{
					mc.quest.reduce_ammo = "on";
					LAi_QuestDelay("pistol_ranking_list", 0.1);
				}
			}
		}
	//JRH

	// TIH --> slight reordering of process - Jul10'06
	// lose crew and money first before the time span
	mc.Ship.crew.quantity = makeint(sti(mc.Ship.crew.quantity) * (5 + rand(3))/10);// 20-50% loss
	mc.money = makeint(sti(mc.money) * (4 + rand(5))/10);// 10-60% loss

	// figure their dmgs here, before the time span, then we adjust dmgs AFTER the time span
	int degradedHP = makeint(sti(mc.ship.hp) * (5 + rand(3))/10);// 20-50% loss
	int degradedSP = makeint(sti(mc.ship.sp) * (5 + rand(3))/10);// 20-50% loss

	// time span moved here as to apply to both tavern girl and NO tavern girl
	WaitDate("", 0,0,4,0,0);// 4 days

	// damage is applied after time span so hull and sails dont get auto-repaired during 4 days
	mc.ship.hp = degradedHP;// 20-50% loss
	mc.ship.sp = degradedSP;// 20-50% loss
	// TIH <--

// KK -->
	//start bedroomscene
	WaitDate("", 0,0,4,0,0);

    //JRH -->
	if(islandID == "Redmond")
	{
		if(CheckAttribute(mc,"quest.Rdm_officiant") && mc.quest.Rdm_officiant == "Claire")
		{
			ResurrectingOfficiant = characterFromID("Redmond_officiant_jrh");
		}
		else
		{
			ResurrectingOfficiant = characterFromID("Redmond_officiant");
		}
	}
	else ResurrectingOfficiant = GetTownOfficiant(TownID);

	if (GetActualNationRelation2MainCharacter(TownNation) == RELATION_ENEMY && CheckAttribute(ResurrectingOfficiant, "resurrection.shore") == true && FindLocation(ResurrectingOfficiant.resurrection.shore) > 0) {
		mc.location.from_sea = ResurrectingOfficiant.resurrection.shore;
		PlaceFleetNearShore(mc.location.from_sea);
	}
	ResurrectingOfficiant.isResurrecting = true;
	PostVideoAndQuest("Blaze_land_dead", 0.0, "PreResurrection");
// <-- KK
// TIH <-- process cleaning
}

void GameOverOrg(string sName)	//ccc original GameOver function
{
	ref mc;
	int nSelect;
	string sFileName;
	//ResetSoundScheme();
	//PauseAllSounds();
	ResetSound();
	EngineLayersOffOn(false);

	mc = GetMainCharacter();

	ClearEvents();
	ClearPostEvents();
	DeleteEntities();

	if(sti(InterfaceStates.Launched)) {
		UnloadSegment(Interfaces[CurrentInterface].SectionName);
	}

	if(LoadSegment("Interface\BaseInterface.c"))
	{
		InitBaseInterfaces();
		UnloadSegment("Interface\BaseInterface.c");
	}
	InitSound();

	SetEventHandler(EVENT_END_VIDEO,"LaunchMainMenu_afterVideo",0);

	switch(sName)
	{
		case "sea":
			nSelect = rand(2);
			sFileName = "skeleton_on_beach";
			switch(nSelect)
			{
				case 0: sFileName = "skeleton_on_beach"; break;
				case 1: sFileName = "undersea"; break;
				case 2: sFileName = "Sharks_attack"; break;
			}
			StartPostVideo(sFileName,1);
		break;

		case "kraken":
			StartPostVideo("undersea",1);
		break;

		case "boarding":
			StartPostVideo("skeleton_on_beach",1);
		break;

		case "land":
			StartPostVideo("blaze_land_dead",1);
		break;

		case "mutiny":
			StartPostVideo("blaze_mutiny_dead",1);
		break;
	}
	InterfaceStates.Buttons.Resume.enable = false;
	InterfaceStates.Buttons.Save.enable = false;
}
//ccc survival <-
